Bug 65964 - video in inactive window overlaps active window - Radeon 7870, Gallium, Glamor
Summary: video in inactive window overlaps active window - Radeon 7870, Gallium, Glamor
Status: RESOLVED FIXED
Alias: None
Product: xorg
Classification: Unclassified
Component: Server/Acceleration/glamor (show other bugs)
Version: git
Hardware: Other All
: medium minor
Assignee: Zhigang Gong
QA Contact:
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2013-06-20 11:07 UTC by Damian Nowak
Modified: 2013-09-23 09:00 UTC (History)
2 users (show)

See Also:
i915 platform:
i915 features:


Attachments
dmesg (70.23 KB, text/plain)
2013-06-20 14:14 UTC, Damian Nowak
no flags Details
Xorg.0.log (106.67 KB, text/plain)
2013-06-20 14:15 UTC, Damian Nowak
no flags Details
java-app (26.44 KB, image/png)
2013-06-20 14:21 UTC, Damian Nowak
no flags Details
screenshot (188.64 KB, image/jpeg)
2013-09-13 16:53 UTC, Vadim Girlin
no flags Details
Fix RegionContainsRect test for PutImage (1.31 KB, patch)
2013-09-17 11:27 UTC, Michel Dänzer
no flags Details | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Damian Nowak 2013-06-20 11:07:35 UTC
When video is playing, I can't cover a part of video with a different window. Video playback overlaps my current window, although it's not active.

http://upload.nowaker.net/nwkr/1371726083_overlap-1.png
http://upload.nowaker.net/nwkr/1371726090_overlap-2.png

Video playback doesn't overlap the video if a different window totally covers it.


After I move an overlapped window away from the video playback, it doesn't refresh. I have to move the window outside the screen and back to get it refreshed.

http://upload.nowaker.net/nwkr/1371726295_overlap-3.png



Using x86_64 Arch Linux 3.9.6-1-ARCH, radeon and glamor from git, KDE.
http://upload.nowaker.net/nwkr/1371723485_glxinfo
http://upload.nowaker.net/nwkr/1371724316_xrandr
Comment 1 Alex Deucher 2013-06-20 13:43:31 UTC
Please attach your xorg log and dmesg.  Are you using flash and if so, is this just an issue with flash or does it happen with other movie players?
Comment 2 Damian Nowak 2013-06-20 14:13:44 UTC
Good catch Alex. Playing WMV and AVI (xvid) in mplayer is not affected. So yep, this is probably Flash.
Comment 3 Damian Nowak 2013-06-20 14:14:47 UTC
Created attachment 81113 [details]
dmesg
Comment 4 Damian Nowak 2013-06-20 14:15:18 UTC
Created attachment 81114 [details]
Xorg.0.log
Comment 5 Damian Nowak 2013-06-20 14:21:55 UTC
Created attachment 81115 [details]
java-app

I also recalled that a similar thing happens in IntelliJ IDEA, a Java IDE. In the picture you see a small active window overlapped by the main window. This doesn't happen that often but maybe it's caused by the same thing (video redraws 50 times a second, IDE not that often?).
Comment 6 Damian Nowak 2013-06-20 21:23:53 UTC
Steam for Linux is affected by overlapping as well.
Comment 7 Michel Dänzer 2013-07-11 16:21:58 UTC
(In reply to comment #5)
> This doesn't happen that often but maybe it's caused by the same thing
> (video redraws 50 times a second, IDE not that often?).

Actually, I think that's rather unlikely.

I haven't been able to reproduce either problem. Please provide more detailed instructions, e.g. any configuration details and explicit steps to reproduce the problems.
Comment 8 Damian Nowak 2013-07-11 16:41:37 UTC
etc/X11/xorg.conf.d/99-radeon.conf:

Section "Module"
  Load "dri2"
  Load "glamoregl"
EndSection

Section "Device"
  Identifier "radeon"
  Driver "radeon"
  Option "AccelMethod" "glamor"
EndSection


That's everything I made regarding the configuration. And since I use Arch Linux, I don't have any distro-specific configs like in Ubuntu.

There are no explicit steps to reproduce. It happened every time. What card and OS did you use?

Thank you Michel for your reply.
Comment 9 Michel Dänzer 2013-07-11 16:50:35 UTC
(In reply to comment #8)
> That's everything I made regarding the configuration.

I was rather thinking of the configuration of the desktop environment and apps.


> There are no explicit steps to reproduce. It happened every time.

At least for the IntelliJ problem, please explain in detail the steps you took to create the problem shown on the attached screenshot.
Comment 10 Damian Nowak 2013-07-11 17:08:36 UTC
> I was rather thinking of the configuration of the desktop environment and
> apps.

My KDE is quite tuned I'd say. I will try running Openbox or similar. [1]

> At least for the IntelliJ problem, please explain in detail the steps you took
> to create the problem shown on the attached screenshot.

Any "popup" window that appears *may* be overlapped by the main window. It can be a rename refactoring (Shift+F6), evaluate expression (Alt+F8 during debug) or inspection menu (Alt+Enter on highlighted code). Since this happens randomly I can't provide any explicit steps. But it happens constantly during the work.


[1] I won't be able to do it know. My 7870 burned two weeks ago and I'm now waiting for a new one.
Comment 11 Damian Nowak 2013-08-09 12:44:54 UTC
My 7870 burned a month ago. Now I have a new one so I can continue investigating.

In the meantime there was a kernel update - I now have 3.10.5-1-ARCH instead of 3.9.6-1-ARCH. There were some updates along the way as well, marked as [updated]. I currently have:

mesa 9.1.6-1 [updated]
libdrm 2.4.46-2 [updated]
ati-dri 9.1.6-1 [updated]
llvm-amdgpu-lib-snapshot 20130403-3 [the same]
xf86-video-ati-glamor-git 1:20120730-1 [the same]


> Good catch Alex. Playing WMV and AVI (xvid) in mplayer is not affected.
> So yep, this is probably Flash.

Flash video doesn't overlap the windows any more.

> Steam for Linux is affected by overlapping as well.

Steam STILL overlaps other windows.

> I also recalled that a similar thing happens in IntelliJ IDEA, a Java IDE.
> This doesn't happen that often but maybe it's caused by the same thing (video
> redraws 50 times a second, IDE not that often?).

This needs a day of work with the IDE, it can't be reproduced ad hoc. Since Steam is still affected, I'd guess this does not work as well.


I will follow you suggestion and will try updating the kernel to 3.11-rc4 and mesa to git.
Comment 12 Michel Dänzer 2013-08-09 13:25:39 UTC
(In reply to comment #11)
> Steam STILL overlaps other windows.

Note that Steam is a 32-bit app. Check (e.g. by running it with the environment variable LIBGL_DEBUG=verbose) that it's using direct rendering, and that the radeonsi_dri.so it picks up is from up-to-date Mesa as well.
Comment 13 Damian Nowak 2013-08-20 19:48:53 UTC
3.11-rc6 changed nothing. mesa-git and lib32-mesa-git did. Thank you Michel.
Comment 14 Vadim Girlin 2013-09-13 16:53:04 UTC
Created attachment 85774 [details]
screenshot

I noticed the same issue as described in first comment, updating mesa and other components doesn't help. For me it doesn't happen with flash though (probably because this case was fixed). I noticed it with mythtv frontend, but also it can be reproduced with "mplayer -vo sdl" (and vlc with SDL output).

It's reproducible only when compositing is disabled (Fedora 19, XFCE).
Comment 15 Michel Dänzer 2013-09-17 11:27:32 UTC
Created attachment 85967 [details] [review]
Fix RegionContainsRect test for PutImage

This patch fixes it for me.
Comment 16 Vadim Girlin 2013-09-17 14:00:00 UTC
Fixed for me too, thanks.
Comment 17 Michel Dänzer 2013-09-18 08:06:50 UTC
commit 29c0907d413ad5be2af3480d008018cd7f5a9e85
Author: Michel Dänzer <michel.daenzer@amd.com>
Date:   Tue Sep 17 13:25:02 2013 +0200

    Fix RegionContainsRect test for PutImage
Comment 18 Damian Nowak 2013-09-23 09:00:10 UTC
Confirming. Although I first thoguht latest mesa and kernel resolved the issue, it still appeared from time to time. This fix resolves the issue for good. Thank you.


Use of freedesktop.org services, including Bugzilla, is subject to our Code of Conduct. How we collect and use information is described in our Privacy Policy.